#include <stdio.h>
#include "vector.h"

// 设置函数指针
void vector_set_funcs(Vector *vector)
{
    vector->ctor = vector_init;
    vector->dtor = vector_free;
    vector->push = vector_push_back;
    vector->pop = vector_pop_back;
    vector->at = vector_get;
    vector->getsize = vector_size;
}

// 示例
int main()
{
    Vector vec;
    vector_set_funcs(&vec);
    vec.ctor(&vec);
    for (int i = 0; i < 20; i++)
        vec.push(&vec, i);
    printf("Size: %d\n\n", vec.getsize(&vec));

    for (int i = 0; i < vec.getsize(&vec); i++)
        printf("%d\n", vec.at(&vec, i));
    printf("\n");

    for (int i = 0; i < 30; i++)
    {
        int x = vec.pop(&vec);
        if (~x)
            printf("Pop: %d\n", x);
        else
            printf("Vector Empty\n");
    }
    printf("%d\n", vec.at(&vec, 20));
    vec.getsize(&vec) == 0 ? puts("Yes") : puts("No");
    vec.dtor(&vec);

    return 0;
}
